

import java.util.Scanner;

import unit4.collectionsLib.Queue;

/**
 *    1  :   
 *  
 * @author   ,   ,  , 
 * @version 28/9/2007
 */
public class Chap8workPage1 
{
	public static void main(String[] args) 
	{   
		Scanner in = new Scanner(System.in);
		System.out.print("Enter array size: ");
		int size = in.nextInt();
		
		int[] a = new int[size];
		
		for (int i = 0; i < a.length; i++)
			a[i] = (int)(Math.random()*1000);
		
		System.out.println("Array before radix sort: " + arrToString(a) + "\n");
		
		radixSort(a); //     
		
		System.out.println("Array after radix sort: " + arrToString(a));
	}
	
	public static void radixSort(int[] arr)
	{
		System.out.println("Start radix sort....");
		int k,dig,pow=1;
		
		Queue<Integer>[] qarr = new Queue[10];
		
		for(int i=0; i<qarr.length; i++)
			qarr[i] = new Queue<Integer>();
		
		for (int i = 1; i <= 10; i++)
		{
			System.out.println("\nstep " + i + "\n------");
			for (int j = 0; j < arr.length; j++)
			{
				dig = (arr[j]/pow)%10;
				qarr[dig].insert(arr[j]);
			}
			k = 0;
			for (int j = 0; j < qarr.length; j++)
			{
				System.out.println("qarr["+j+"]: "+qarr[j]);
				while(!qarr[j].isEmpty())
				{
					arr[k]=qarr[j].remove();
					k++;
				}
			}
			System.out.println("Array: " + arrToString(arr));
			pow = pow * 10;
		}
		System.out.println("\nEnd radix sort.\n");
	}
	
	public static String arrToString(int[] arr)
	{
		int i;
		String str = "[";
		
		for (i = 0; i < arr.length-1; i++)
			str = str + arr[i] + ",";

		if(i<arr.length)
			str = str + arr[i];
		
		return str+"]";
	}
}

